var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import { jsx as _jsx } from "react/jsx-runtime";
import * as React from 'react';
import useClickAway from 'react-use/lib/useClickAway';
import classNames from 'classnames';
import useStaticCallback from "../../hooks/useStaticCallback";
import useRegistInputEnterEvent from "../../hooks/useRegistInputEnterEvent";
import calculateNodeHeight from "../_utils/calculateNodeHeight";
import "./style/textarea.css";
var prefixCls = 'dmc-input-textarea';
export var Textarea = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _a;

  var type = props.type,
      status = props.status,
      value = props.value,
      defaultValue = props.defaultValue,
      className = props.className,
      disabled = props.disabled,
      onChange = props.onChange,
      onPressEnter = props.onPressEnter,
      autoSize = props.autoSize,
      onFocus = props.onFocus,
      block = props.block,
      style = props.style,
      restProps = __rest(props, ["type", "status", "value", "defaultValue", "className", "disabled", "onChange", "onPressEnter", "autoSize", "onFocus", "block", "style"]);

  var textareaRef = React.useRef(null);
  var wrapperRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      dom: wrapperRef.current,
      textarea: textareaRef.current,
      focus: function focus() {
        textareaRef.current && textareaRef.current.focus();
      },
      blur: function blur() {
        textareaRef.current && textareaRef.current.blur();
      }
    };
  });

  var _b = React.useState(defaultValue !== null && defaultValue !== void 0 ? defaultValue : ''),
      unControlVal = _b[0],
      setUnControlVal = _b[1];

  var _c = React.useState({}),
      textareaStyles = _c[0],
      setTextareaStyles = _c[1];

  var _d = React.useState(false),
      isFocus = _d[0],
      setIsFocus = _d[1];

  var isControl = ('value' in props);
  var val = isControl ? value !== null && value !== void 0 ? value : '' : unControlVal;
  React.useEffect(function () {
    if (autoSize && textareaRef.current) {
      var _a = autoSize || {},
          minRows = _a.minRows,
          maxRows = _a.maxRows;

      var textareaStyles_1 = calculateNodeHeight(textareaRef.current, false, minRows, maxRows);
      setTextareaStyles(textareaStyles_1);
    }
  }, [autoSize, val]);
  var wrapperCls = classNames("" + prefixCls, (_a = {}, _a[prefixCls + "-" + type] = type, _a[prefixCls + "-block"] = block, _a[prefixCls + "-disabled"] = disabled, _a[prefixCls + "-" + status + "-status"] = status, _a[prefixCls + "-focused"] = isFocus, _a[prefixCls + "-resize"] = !autoSize, _a), className);
  useRegistInputEnterEvent(textareaRef, onPressEnter);
  var handleChange = useStaticCallback(function (e) {
    !isControl && setUnControlVal(e.target.value);
    onChange && onChange(e);
  });
  var handleFocus = useStaticCallback(function (e) {
    setIsFocus(true);
    onFocus && onFocus(e);
  });
  useClickAway(wrapperRef, function () {
    setIsFocus(false);
  });
  return _jsx("div", __assign({
    className: wrapperCls,
    ref: wrapperRef
  }, {
    children: _jsx("textarea", __assign({}, restProps, {
      value: val,
      ref: textareaRef,
      disabled: disabled,
      onChange: handleChange,
      onFocus: handleFocus,
      className: prefixCls + "-textarea",
      style: __assign(__assign({}, style || {}), textareaStyles)
    }), void 0)
  }), void 0);
});
Textarea.defaultProps = {
  autoSize: {
    minRows: 2
  }
};
Textarea.displayName = 'Textarea';
export default Textarea;
var TextareaMemo = /*#__PURE__*/React.memo(Textarea);
TextareaMemo.displayName = 'TextareaMemo';
export { TextareaMemo };

